scala.collection.generic

# GenericTraversableTemplate

#### trait GenericTraversableTemplate[+A, +CC[X] <: GenTraversable[X]] extends HasNewBuilder[A, CC[A]]

A template class for companion objects of ``regular`` collection classes that represent an unconstrained higher-kinded type.

A

  The type of the collection elements.

CC

  The type constructor representing the collection class.

Source
  GenericTraversableTemplate.scala
Since

  2.8

Linear Supertypes
HasNewBuilder[A, CC[A] @scala.annotation.unchecked.uncheckedVariance], AnyRef, Any
Known Subclasses
::, AbsScope, Appended, Appended, Appended, Appended, Appended, Appended, Appended, Appended, Appended, ArrayBuffer, ArraySeq, ArrayStack, Atom, Attribute, BitSet, BitSet, BitSet, BitSet1, BitSet2, BitSetN, Buffer, BufferProxy, BufferWrapper, ByOne, Comment, ConcurrentMap, Cons, Content, DefaultKeySet, DefaultKeySortedSet, DefaultKeySortedSet, DefaultMap, DefaultMap, DefaultMapModel, DefaultValuesIterable, Document, DoubleLinkedList, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, Elem, Empty, EmptyMap, EmptySet, EmptyView, EmptyView, EmptyView, EmptyView, EmptyView, EmptyView, EmptyView, EntityRef, Exclusive, Filtered, Filtered, Filtered, Filtered, Filtered, Filtered, Filtered, Filtered, FlatMapped, FlatMapped, FlatMapped, FlatMapped, FlatMapped, FlatMapped, FlatMapped, Forced, Forced, Forced, Forced, Forced, Forced, Forced, Forced, Forced, GenIterable, GenIterableView, GenIterableViewLike, GenMap, GenSeq, GenSeqView, GenSeqViewLike, GenSet, GenTraversable, GenTraversableView, GenTraversableViewLike, GenericParMapTemplate, GenericParTemplate, GenericSetTemplate, Group, HashMap, HashMap, HashMap1, HashSet, HashSet, HashSet1, HashTrieMap, HashTrieSet, History, ImmutableDefaultKeySet, ImmutableMapAdaptor, ImmutableSetAdaptor, Impl, Inclusive, Inclusive, IndexedSeq, IndexedSeq, IndexedSeq, IndexedSeqView, Indices, IntMap, Iterable, Iterable, Iterable, IterableForwarder, IterableProxy, IterableView, IterableViewLike, JCollectionWrapper, JConcurrentMapWrapper, JDictionaryWrapper, JIterableWrapper, JListWrapper, JMapWrapper, JMapWrapperLike, JPropertiesWrapper, JSetWrapper, LinearSeq, LinearSeq, LinearSeq, LinkedHashMap, LinkedHashSet, LinkedList, List, ListBuffer, ListMap, ListMap, ListSet, LongMap, Map, Map, Map, Map1, Map2, Map3, Map4, MapProxy, MapProxy, MapProxy, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, MetaData, MultiMap, MutableList, Nil, Node, Node, Node, NodeBuffer, NodeSeq, Null, NumericRange, ObservableBuffer, ObservableMap, ObservableSet, OpenHashMap, PCData, PagedSeq, ParArray, ParHashMap, ParHashMap, ParHashSet, ParHashSet, ParIterable, ParIterable, ParIterable, ParIterableView, ParIterableViewLike, ParMap, ParMap, ParMap, ParRange, ParSeq, ParSeq, ParSeq, ParSeqView, ParSeqViewLike, ParSet, ParSet, ParSet, ParVector, Patched, Patched, Patched, Patched, PicklerEnv, PrefixedAttribute, Prepended, Prepended, Prepended, Prepended, PriorityQueue, PriorityQueueProxy, ProcInstr, Queue, Queue, QueueProxy, Range, RefBuffer, ResizableArray, Reversed, Reversed, Reversed, Reversed, Reversed, RevertibleHistory, Scope, Script, SelectionSet, Seq, Seq, Seq, SeqForwarder, SeqProxy, SeqView, SeqViewLike, Set, Set, Set, Set1, Set2, Set3, Set4, SetProxy, SetProxy, SetProxy, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, SortedMap, SortedMap, SortedSet, SortedSet, SpecialNode, Stack, Stack, StackProxy, Stream, StreamView, StreamViewLike, StringBuilder, SynchronizedBuffer, SynchronizedMap, SynchronizedPriorityQueue, SynchronizedQueue, SynchronizedSet, SynchronizedStack, SystemProperties, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, Text, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Traversable, Traversable, Traversable, TraversableForwarder, TraversableProxy, TraversableView, TraversableViewLike, TreeMap, TreeSet, UnPicklerEnv, Unparsed, UnprefixedAttribute, UnrolledBuffer, ValueSet, Vector, WeakHashMap, WithDefault, WithDefault, WithDefault, WrappedArray, WrappedString, Zipped, Zipped, Zipped, Zipped, Zipped, Zipped, Zipped, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, columns, indices, ofBoolean, ofByte, ofChar, ofDouble, ofFloat, ofInt, ofLong, ofRef, ofShort, ofUnit, pages, rows
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. GenericTraversableTemplate
2. HasNewBuilder
3. AnyRef
4. Any

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def companion: GenericCompanion[CC]

   The factory companion object that builds instances of class CC.

   The factory companion object that builds instances of class CC. (or its `Iterable` superclass where class CC is not a `Seq`.)

2. #### abstract def foreach[U](f: (A) ⇒ U): Unit

   Applies a function `f` to all elements of this collection.

   Applies a function `f` to all elements of this collection.

   U

     the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

   f

     the function that is applied for its side-effect to every element. The result of function `f` is discarded.

3. #### abstract def head: A

   Selects the first element of this collection.

   Selects the first element of this collection.

   returns

     the first element of this collection.

   Exceptions thrown
     `NoSuchElementException`

     if the collection is empty.

4. #### abstract def isEmpty: Boolean

   Tests whether this collection is empty.

   Tests whether this collection is empty.

   returns

     `true` if the collection contain no elements, `false` otherwise.

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()
   Note

     not specified by SLS as a member of AnyRef

8. #### final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef

9. #### def equals(arg0: Any): Boolean

   The equality method for reference types.

   The equality method for reference types. See equals in Any.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

10. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

11. #### abstract def flatten[B]: CC[B]

    [use case] Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    [use case]

    Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new collection resulting from concatenating all element collections.

12. #### def flatten[B](implicit asTraversable: (A) ⇒ TraversableOnce[B]): CC[B]

    Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    Converts this collection of traversable collections into a collection formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of collection. For example:

         val xs = List(Set(1, 2, 3), Set(1, 2, 3))
         // xs == List(1, 2, 3, 1, 2, 3)

         val ys = Set(List(1, 2, 3), List(3, 2, 1))
         // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    asTraversable

      an implicit conversion which asserts that the element type of this collection is a `Traversable`.

    returns

      a new collection resulting from concatenating all element collections.

13. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this collection.

    [use case]

    Applies a function `f` to all elements of this collection.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

14. #### def genericBuilder[B]: Builder[B, CC[B]]

    The generic builder that builds instances of CC at arbitrary element types.

15. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

16. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

17. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

18. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### def newBuilder: Builder[A, CC[A]]

    The builder that builds instances of type CC[A]

    The builder that builds instances of type CC[A]

    Attributes
      protected[this]
    Definition Classes
      GenericTraversableTemplate → HasNewBuilder

20. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

21. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

22. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

23. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

24. #### def transpose[B](implicit asTraversable: (A) ⇒ GenTraversableOnce[B]): CC[CC[B]]

    Transposes this collection of traversable collections into a collection of collections.

    Transposes this collection of traversable collections into a collection of collections.

    B

      the type of the elements of each traversable collection.

    asTraversable

      an implicit conversion which asserts that the element type of this collection is a `Traversable`.

    returns

      a two-dimensional collection of collections which has as nth row the nth column of this collection.

    Annotations
      @migration
    Migration

      (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

    Exceptions thrown
      `IllegalArgumentException`

      if all collections in this collection are not of the same size.

25. #### def unzip[A1, A2](implicit asPair: (A) ⇒ (A1, A2)): (CC[A1], CC[A2])

    Converts this collection of pairs into two collections of the first and second half of each pair.

    Converts this collection of pairs into two collections of the first and second half of each pair.

    asPair

      an implicit conversion which asserts that the element type of this collection is a pair.

    returns

      a pair collections, containing the first, respectively second half of each element pair of this collection.

26. #### def unzip3[A1, A2, A3](implicit asTriple: (A) ⇒ (A1, A2, A3)): (CC[A1], CC[A2], CC[A3])

    Converts this collection of triples into three collections of the first, second, and third element of each triple.

    Converts this collection of triples into three collections of the first, second, and third element of each triple.

    asTriple

      an implicit conversion which asserts that the element type of this collection is a triple.

    returns

      a triple collections, containing the first, second, respectively third member of each element triple of this collection.

27. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

28. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

29. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from HasNewBuilder[A, CC[A] @scala.annotation.unchecked.uncheckedVariance]

### Inherited from AnyRef

### Inherited from Any